Generate[] GENERATE = {
  new Generate("Contra", 'q'),
  new Generate("Noise", 'w'),
  new Generate("Snow", 'e'),
  new Generate("Glitch", 'r'),
  new Generate("Flatten", 't')
};


/* ----- */


class Generate {
  String name;
  char shortcut;
  Generate(String iname, char ishortcut) {
    name = iname;
    shortcut = ishortcut;
  }
}


/* ----- */


void addElement(String element) {
  
  if(element == "Contra") {
    output.beginDraw();
    int method = int(random(0,5));
    if(method==0) {
      int stop = int(random(0,W));
      for(int x=0; x < stop; x++) {
        for(int y=0; y < H; y++) {
          output.set(x, y, color( 255-brightness(output.get(x,y)) ) );
        }
      }
    } else if(method==1) {
      int stop = int(random(0,W));
      for(int x=stop; x < W; x++) {
        for(int y=0; y < H; y++) {
          output.set(x, y, color( 255-brightness(output.get(x,y)) ) );
        }
      }
    } else if(method==2) {
      int stop = int(random(0,H));
      for(int x=0; x < W; x++) {
        for(int y=0; y < stop; y++) {
          output.set(x, y, color( 255-brightness(output.get(x,y)) ) );
        }
      }
    } else if(method==3) {
      int stop = int(random(0,H));
      for(int x=0; x < W; x++) {
        for(int y=stop; y < H; y++) {
          output.set(x, y, color( 255-brightness(output.get(x,y)) ) );
        }
      }
    }
    output.endDraw();
  }
  
  
  
  if(element == "Noise") {
    output.beginDraw();
    for(int x=0; x<W; x++) {
      for(int y=0; y<H; y++) {
        //output.set(x, y, int(random(2))*255 );
        output.set(x, y, int(random(0,256)) );        
      }
    }
    output.endDraw();
  }
  
  
  
  if(element == "Snow") {
    output.beginDraw();
    for(int x=0; x<500; x++) {
        output.set( int(random(0,W)), int(random(0,H)), 255 );
    }
    output.endDraw();
  }
  
  
  
  if(element == "Glitch") {
    output.beginDraw();
    
    int count = int(random(1,10));
    for(int i=0; i < count; i++) {
      
      int rw = int(random(1,300/scale));
      int rh = int(random(1,300/scale));
      int sx = int(random(0,W-rw));
      int sy = int(random(0,H-rh));
      int cx = int(random(0,W-rw));
      int cy = int(random(0,H-rh));
    
      for(int x=0; x < rw; x++) {
        for(int y=0; y < rh; y++) {
          output.set(sx+x, sy+y, color( brightness(output.get(cx+x,cy+y)) ) );
        }
      }
      
    }
  
  }
  
  if(element == "Flatten") {
    output.beginDraw();
    
    int s = int(random(0,256));
    int range = int(random(10,50));
    
    for(int x=0; x < W; x++) {
      for(int y=0; y < H; y++) {
        int state = int ( brightness(output.get(x,y)) );
        if( state > s-range && state < s+range) {
          output.set(x, y, color(s) );
        }
      }
    }
    
    output.endDraw();
  }
  
  
}
