Image[] IMAGES = {
  new Image("images/1.png",'q'),
  new Image("images/2.png",'w'),
  new Image("images/3.png",'e'),
  new Image("images/4.png",'r'),
  new Image("images/5.png",'t'),
  new Image("images/6.png",'a'),
  new Image("images/7.png",'s'),
  new Image("images/8.png",'d'),
  new Image("images/9.png",'f'),
  new Image("images/10.png",'g'),
  new Image("images/11.png",'z'),
  new Image("images/12.png",'x'),
  new Image("images/13.png",'c')
};


/* ----- */


class Image {
  String filename;
  char shortcut;
  PImage thumb;
  PImage image;
  PImage mask;
  Image(String ifilename, char ishortcut) {
    filename = ifilename;
    shortcut = ishortcut;
  }
  void load() {
    int thumbSize = 40;
    thumb = loadImage(filename);
    thumb.resize(thumbSize, thumbSize);
    image = loadImage(filename);
    image.filter(GRAY);
    image.resize(W, H);
    mask = loadImage(filename);
    mask.filter(THRESHOLD, 0.1);
    mask.resize(W, H);
    image.mask(mask);
  }
}

void loadImages() {
  for(int i=0; i<IMAGES.length; i++) {
    IMAGES[i].load();
  }
}

/* ----- */



void addImage(PImage img) {  
  output.beginDraw();
  output.image(img, W/2, H/2, W, H);
  output.endDraw();
}
